// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "file.h"
#include <gtk/gtk.h>

int get_nb_line(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

int get_nb_param(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            if(line[0]=='[')i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

int set_param(char* file, char* name, int nb, GSList* gslist)
{
    int i=0,j=0;
    FILE* f = NULL;

//    printf("Entering in set param with %s !!\n",file);

    f=fopen(file,"a+");
    fprintf(f,"[%s]\n",name);

//    printf("length of list : %d\n",nb);

    while(i<nb)
    {
        if(j==2)
        {
            fprintf(f,"[%s]\n",name);
            j=0;
        }
        fprintf(f,"%s\n",g_slist_nth_data (gslist, i));
        i++,j++;
    }
    fclose(f);

//    printf("Exiting set param !!\n");

    return 0;
}

int get_tree_view_row(char* file,char* name)
{
    int row=0,ok=0,compok=1;
    FILE* f=NULL;
    char save[1000];
    int eof=0;
    int i=0;
    int j=0;
    int nb=0;
    int nb_param=0;

    nb_param = get_nb_line(file);

    if(nb_param!=-1)
    {
        f=fopen(file,"r");
        if(f!=NULL)
        {
            while(nb_param>0)
            {
                if(fgets(save,1000,f)==NULL)perror("Erreur de lecture dans le fichier liststore");
                nb_param--;
                if(strcmp(save,name)==0)break;
                if(nb_param!=0)row++;
                else row=-1;
            }

            fclose(f);
        }
        else
        {
            perror("Fichier liststore inaccessible");
        }

    }
    else
    {
        perror("Fichier liststore inaccessible");
    }

    return row;
}


int modify_line(char* file,int line,int pid)
{
    FILE* f=NULL;
    FILE* f1=NULL;
    char save[1000];
    char save1[1000];
    int eof=0;
    int i=0;
    int j=0,k=0;
    GString* cmd=NULL;

    cmd=g_string_new("cp '");
    g_string_append(cmd,file);
    g_string_append(cmd,"' '");
    g_string_append(cmd,file);
    g_string_append(cmd,"1'");
    system(cmd->str);

    free(g_string_free(cmd,FALSE));

    cmd=g_string_new(file);
    g_string_append(cmd,"1");
    f1=fopen(cmd->str,"r");

    free(g_string_free(cmd,FALSE));

    f=fopen(file,"w+");
    fgets(save,1000,f1);
    while(!eof)
    {
        eof=feof(f1);
        if(i==line)
        {
            while(save[j]!=',') j++;
            j++;
            while(save[j]!='\n' && save[j]!='\0')
            {
                save1[k]=save[j];
                j++;
                k++;
            }
            if(!eof)
            {
                save1[k]='\n';
                k++;
            }
            save1[k]='\0';
            fprintf(f,"%d,%s",pid,save1);
        }
        else
        {
            fprintf(f,"%s",save);
        }
        i++;
        fgets(save,1000,f1);
    }
    fclose(f);
    fclose(f1);
    return 0;
}

