#include "exec.h"

int cpt_block(char* name)
{
    int nb=0;
    int i=0;
    int quot_block=0;
    int normal_block=0;
    int db_quot_block=0;

    while(i<strlen(name))
    {
        if(!quot_block && !normal_block && !db_quot_block)
        {
            if(name[i]=='\'') quot_block=1;
            else if(name[i]=='\"') db_quot_block=1;
            else if(name[i]!=' ') normal_block=1;
        }
        else if(quot_block)
        {
            while(name[i]!='\'' && i<strlen(name))i++;
            nb++;
            quot_block=0;
        }
        else if(db_quot_block)
        {
            while(name[i]!='\"' && i<strlen(name))i++;
            nb++;
            db_quot_block=0;
        }
        else if(normal_block)
        {
            while(name[i]!=' ' && i<strlen(name)) i++;
            nb++;
            normal_block=0;
        }
        i++;
    }
    return nb;
}

void give_block(char* name,char* block,int num)
{
    int nb=0;
    int i=0;
    int j=0;
    int quot_block=0;
    int normal_block=0;
    int db_quot_block=0;
    char tmp[1000];

    while(i<strlen(name))
    {
        if(!quot_block && !normal_block && !db_quot_block)
        {
            if(name[i]=='\'') quot_block=1;
            else if(name[i]=='\"') db_quot_block=1;
            else if(name[i]!=' ') normal_block=1;
        }
        else if(quot_block)
        {
            j=0;
            while(name[i]!='\'' && name[i]!='\0')
            {
                tmp[j]=name[i];
                i++;
                j++;
            }
            tmp[j]='\0';
            nb++;
            quot_block=0;
        }
        else if(db_quot_block)
        {
            j=0;
            while(name[i]!='\"' && name[i]!='\0')
            {
                tmp[j]=name[i];
                j++;
                i++;
            }
            tmp[j]='\0';
            nb++;
            db_quot_block=0;
        }
        else if(normal_block)
        {
            j=0;
            while(name[i]!=' ' && name[i]!='\0')
            {
                tmp[j]=name[i-1];
                j++;
                i++;
            }
            tmp[j]=name[i-1];
            j++;
            tmp[j]='\0';
            nb++;
            normal_block=0;
        }
        if(nb==num)
        {
            strcpy(block,tmp);
            break;
        }
        i++;
    }
}

int spawn (char* name)
{
    pid_t child_pid;
    int nb_block;
    int i=0;
    char **spawn;

    nb_block=cpt_block(name);
    spawn=malloc(sizeof(char*)*(nb_block+1));
    spawn[nb_block]=NULL;

    while(i<nb_block)
    {
        spawn[i]=malloc(sizeof(char)*1000);
        i++;
    }

    i=0;
    while(i<nb_block)
    {
        give_block(name,spawn[i],i+1);
        i++;
    }

    // Duplicate this process.
    child_pid = fork ();

    if (child_pid != 0)
    {
        i=0;
        while(i<nb_block)
        {
            free(spawn[i]);
            i++;
        }
        free(spawn);
        // This is the parent process.
        return child_pid;
    }
    else {
    // Now execute PROGRAM, searching for it in the path.
    execvp(spawn[0],spawn);
    // The execvp function returns only if an error occurs.
    fprintf (stderr, "Program is close, or an error occurred in execvp\n");
    abort ();
    }
}
