#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int get_nb_param(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

int main(int argc, char *argv[])
{
    FILE* f=NULL;
    char line[1000];
    int h1,min1,sec1,h2,min2,sec2;
    int check0,check1,check2,check3,check4;
    char process[1000];
    char num_pid[1000];

    char filename[1000];
    char cmd[1000];
    char cmd1[1000];

    int i,j;
    int pvsu=1;

    struct timeval tv;
    struct tm* ptm;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    printf("argc=%d\n",argc);

    if(argc==3)
    {
        f=fopen(argv[1],"r");
        if(f!=NULL)
        {
            printf("File exists: %02d:%02d:%02d\n",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
            /** LOAD **/
            fgets(line,1000,f);
            fgets(line,1000,f);
            sscanf(line,"%d",&check0);
            fgets(line,1000,f);
            sscanf(line,"%d",&h1);
            fgets(line,1000,f);
            sscanf(line,"%d",&min1);
            fgets(line,1000,f);
            sscanf(line,"%d",&sec1);

            fgets(line,1000,f);
            sscanf(line,"%d",&check1);
            fgets(line,1000,f);
            sscanf(line,"%d",&h2);
            fgets(line,1000,f);
            sscanf(line,"%d",&min2);
            fgets(line,1000,f);
            sscanf(line,"%d",&sec2);

            fgets(line,1000,f);
            sscanf(line,"%d",&check2);
            fgets(line,1000,f);
            strcpy(process,line);
            if(strlen(process)>0)process[strlen(process)-1]='\0';

            fgets(line,1000,f);
            sscanf(line,"%d",&check3);
            fgets(line,1000,f);
            strcpy(num_pid,line);
            num_pid[strlen(num_pid)-1]='\0';

            fgets(line,1000,f);
            sscanf(line,"%d",&check4);

            fclose(f);

            printf("Load:%d %d %d %d %d %d %d %d %d %s %d %s %d\n",check0,h1,min1,sec1,check1,h2,min2,sec2,check2,process,check3,num_pid,check4);

            if(check4==1 || (check0==0 && check1==0 && check2==0 && check3==0))
            {
                printf("Fermeture\n");
                exit(1);
            }

            if(check0==1)
            {
                // Prepare stop date
                printf("%d+%d:%d+%d:%d+%d\n",h1,ptm->tm_hour,min1,ptm->tm_min,sec1,ptm->tm_sec);
                i=sec1;
                j=0;
                sec1=(ptm->tm_sec+sec1)%60;
                if(sec1<i) j=1;

                i=min1;
                min1=(ptm->tm_min+min1+j)%60;
                j=0;
                if(min1<i) j=1;

                i=h1;
                h1=(ptm->tm_hour+h1+j)%24;

                printf("New hour: %02d:%02d:%02d\n",h1,min1,sec1);
            }

            if(check2==1)
            {
                // Prepare file test
                strcpy(filename,"/tmp/schedio_extinct_test.tmp");
                f=fopen(filename,"w+");
                fclose(f);
                strcpy(cmd,"ps -e | grep ");
                strcat(cmd,process);
                strcat(cmd," >> /tmp/schedio_extinct_test.tmp");
            }

            if(check3==1)
            {
                // Prepare file test
                strcpy(filename,"/tmp/schedio_extinct_test.tmp");
                f=fopen(filename,"w+");
                fclose(f);
                strcpy(cmd1,"ps ");
                strcat(cmd1,num_pid);
                strcat(cmd1," >> /tmp/schedio_extinct_test.tmp");
            }

            f=fopen(argv[2],"w+");
            fprintf(f,"Extinction du système\n");
            fprintf(f,"Période de visualisation: 15s\n");
            fprintf(f,"État:Chargement réussi\n");
            if(check0==1)fprintf(f,"Extinction par l'option 1:%02d:%02d:%02d\n",h1,min1,sec1);
            if(check1==1)fprintf(f,"Extinction par l'option 2:%02d:%02d:%02d\n",h2,min2,sec2);
            if(check2==1)fprintf(f,"Attente de la fin de:%s\n",process);
            if(check3==1)fprintf(f,"Attente de la fin de:%s\n",num_pid);
            fprintf(f,"Heure de la visualisation:%02d:%02d:%02d",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
            fclose(f);

            printf("Verif_on\n");
            while(1)
            {
                gettimeofday(&tv,NULL);
                ptm=localtime(&tv.tv_sec);
                if(check0==1)
                {
                    if(h1==(ptm->tm_hour) && min1==(ptm->tm_min) && sec1==(ptm->tm_sec))
                    {
                        printf("shutdown1 !\n");
                        system("shutdown -h now");
                        break;
                    }
                    if(h1==(ptm->tm_hour) && min1==(ptm->tm_min) && (sec1+1)==(ptm->tm_sec))
                    {
                        printf("shutdown1 !\n");
                        system("shutdown -h now");
                        break;
                    }
                    if(h1==(ptm->tm_hour) && min1==(ptm->tm_min) && (sec1+2)==(ptm->tm_sec))
                    {
                        printf("shutdown1 !\n");
                        system("shutdown -h now");
                        break;
                    }
                }

                if(check1==1)
                {
                    if(h2==(ptm->tm_hour) && min2==(ptm->tm_min) && sec2==(ptm->tm_sec))
                    {
                        printf("shutdown2 !\n");
                        system("shutdown -h now");
                        break;
                    }
                    if(h2==(ptm->tm_hour) && min2==(ptm->tm_min) && (sec2+1)==(ptm->tm_sec))
                    {
                        printf("shutdown2 !\n");
                        system("shutdown -h now");
                        break;
                    }
                    if(h2==(ptm->tm_hour) && min2==(ptm->tm_min) && (sec2+2)==(ptm->tm_sec))
                    {
                        printf("shutdown2 !\n");
                        system("shutdown -h now");
                        break;
                    }
                }

                if(check2==1)
                {
                    f=fopen(filename,"w+");
                    fclose(f);
                    system(cmd);
                    i=get_nb_param(filename);
                    if(i==-1) printf("Shutdown3 !\n");
                }

                if(check3==1)
                {
                    f=fopen(filename,"w+");
                    fclose(f);
                    system(cmd1);
                    i=get_nb_param(filename);
                    if(i==1) printf("Shutdown4 !\n");
                }

                pvsu=pvsu%15;

                if(pvsu==0)
                {
                    f=fopen(argv[2],"w+");
                    fprintf(f,"Extinction du système\n");
                    fprintf(f,"Période de visualisation: 15s\n");
                    fprintf(f,"État: En fonctionnement\n");
                    if(check0==1)fprintf(f,"Extinction par l'option 1:%02d:%02d:%02d\n",h1,min1,sec1);
                    if(check1==1)fprintf(f,"Extinction par l'option 2:%02d:%02d:%02d\n",h2,min2,sec2);
                    if(check2==1)fprintf(f,"Attente de la fin de:%s\n",process);
                    if(check3==1)fprintf(f,"Attente de la fin de:%s\n",num_pid);
                    fprintf(f,"Heure de la visualisation:%02d:%02d:%02d",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
                    fclose(f);
                }
                pvsu++;

                sleep(1);
            }
        }
    }

    return 0;
}
