#include <stdlib.h>
#include <gtk/gtk.h>
#include "configure.h"

GString* get_profil(char* file,int *choice)
{
    FILE* f=NULL;
    char line[1000];
    GString* string=NULL;
    int len=0;

    f=fopen(file,"r");
    fgets(line,1000,f); // Pass [Window]
    fgets(line,1000,f); // found the profil
    len=strlen(line);
    line[len-1]='\0'; // On retire le backslash n
    string=g_string_new(line);

    fgets(line,1000,f); // found the create state
    if(line[0]=='1') *choice=1;
    fgets(line,1000,f); // found the modif state

    if(line[0]=='1') *choice=2;
    fgets(line,1000,f); // found the replace state

    if(line[0]=='1') *choice=3;
    fgets(line,1000,f); // found the suppression state

    if(line[0]=='1') *choice=4;
    fgets(line,1000,f); // found the suppression state

    if(line[0]=='1') *choice=5;
    fclose(f);
    return string;
}

int profil_exists(GString* profil)
{
    GString* compare=NULL;
    FILE* f=NULL;
    char line[1000];
    int equal=0;
    int len;

    f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/restrict_profil_test.tmp","w+");
    fclose(f);

    compare=g_string_new("ls /home >> ");
    g_string_append(compare,"/usr/share/schedio/plugin_ncy/restriction/tmp/restrict_profil_test.tmp");
    system(compare->str);

    free(g_string_free(compare,FALSE));

    compare=g_string_new("/usr/share/schedio/plugin_ncy/restriction/tmp/restrict_profil_test.tmp");
    f=fopen(compare->str,"r");
    free(g_string_free(compare,FALSE));

    while(!feof(f) && !equal)
    {
        fgets(line,1000,f);
        len=strlen(line);
        line[len-1]='\0'; // On retire le backslash n
        compare=g_string_new(line);
        printf("Found:%s\n",compare->str);
        if(g_string_equal(profil,compare)) equal=1;
        free(g_string_free(compare,FALSE));
    }
    fclose(f);

    return equal;
}


int main (int argc, char *argv[])
{
    GtkWidget *button = NULL;
    GtkWidget *win = NULL;
    GtkWidget *vbox = NULL;
    GtkWidget *hbox = NULL;
    GString* profil = NULL;
    GString* win_name=NULL;
    GtkWidget* title=NULL;
    GtkWidget* label=NULL;
    GSList* list=NULL;
    gint to_make=0;
    FILE* f=NULL;
    char cmd[1000];

    if(argc==2)
    {
        /* Initialize GTK+ */
        g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
        gtk_init (&argc, &argv);
        g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

        profil=get_profil(argv[1],&to_make);
        printf("Profil:%s To_make:%d\n",profil->str,to_make);

        if(profil_exists(profil))
        {
            printf("Existing profile\n");
            strcpy(name,profil->str);

            strcpy(cmd,"rm -r /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
            strcat(cmd,name);
            system(cmd);

            win_name=g_string_new("");
            if(to_make==1) g_string_append(win_name,"Modifier le profil de restriction de ");
            if(to_make==2) g_string_append(win_name,"Remplacer le profil de restriction de ");
            if(to_make==3) g_string_append(win_name,"Supprimer le profil de restriction de ");
            if(to_make==4) g_string_append(win_name,"Activer/Désactiver les restrictions");
            if(to_make==5) g_string_append(win_name,"Activer/Désactiver le script au démarrage");
            if(to_make<4)g_string_append(win_name,profil->str);

            /* Create the main window */
            win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
            gtk_container_set_border_width (GTK_CONTAINER (win),2);
            gtk_window_set_title (GTK_WINDOW (win), win_name->str);
            gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
            gtk_widget_realize (win);
            g_signal_connect (win, "destroy", gtk_main_quit, win);

            /* Create a vertical box with buttons */
            vbox = gtk_vbox_new (FALSE, 6);
            gtk_container_add (GTK_CONTAINER (win), vbox);
            hbox = gtk_hbox_new (TRUE, 6);

            button = gtk_button_new_with_label ("Annuler");
            g_signal_connect (button, "clicked", gtk_main_quit, NULL);
            gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

            list=g_slist_append(list,(gpointer)win);// ADD TO GSLIST
            g_slist_append(list,(gpointer)button);// ADD TO GSLIST

            if(to_make!=3 && to_make!=4 && to_make!=5)
            {
                if(to_make==1)
                {
                    strcpy(cmd,"mkdir /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
                    strcat(cmd,name);
                    system(cmd);

                    strcpy(cmd,"mkdir /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
                    strcat(cmd,name);
                    strcat(cmd,"/calendrier");
                    system(cmd);

                    strcpy(cmd,"cp -r /usr/share/schedio/plugin_ncy/restriction/files/");
                    strcat(cmd,name);
                    strcat(cmd," /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
                    system(cmd);
                }
                else
                {
                    strcpy(cmd,"mkdir /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
                    strcat(cmd,name);
                    system(cmd);

                    strcpy(cmd,"mkdir /usr/share/schedio/plugin_ncy/restriction/tmp/config/");
                    strcat(cmd,name);
                    strcat(cmd,"/calendrier");
                    system(cmd);
                }

                current_step=0;
                gtk_window_resize(GTK_WINDOW(win),500,170);
                title=gtk_label_new("<big><b>Étape 1 sur 3: Restrictions permanentes</b></big>");
                gtk_label_set_use_markup(title, TRUE);
                gtk_box_pack_start (GTK_BOX (vbox), title, FALSE, FALSE, 10);

                label=gtk_label_new("Les logiciels que vous gérez via ce mode seront toujours interdits à cet utilisateur.\n\nExemple: /usr/bin/vlc interdira le programme vlc.\nIl est important de mettre le lien complet vers l'executable.");
                gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

                button = gtk_button_new_with_label("Gérer ");
                gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(configure),NULL);
                gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 10);

                button = gtk_button_new_with_label("Étape suivante");

                g_slist_append(list,(gpointer)title);// ADD TO GSLIST
                g_slist_append(list,(gpointer)label);// ADD TO GSLIST
                g_slist_append(list,(gpointer)hbox);// ADD TO GSLIST
                g_slist_append(list,(gpointer)vbox);// ADD TO GSLIST
                g_slist_append(list,(gpointer)button);// ADD TO GSLIST

                gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(step_two),list);
                //gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
                gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
                gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);
            }
            else if(to_make==3)
            {
                label=gtk_label_new("Êtes-vous sûr de vouloir supprimer ce profil et sa configuration ?");
                gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

                button = gtk_button_new_with_label("Supprimer le profil");
                gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(sup_restrictions),NULL);
                gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
                gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
                gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);
                gtk_window_resize(GTK_WINDOW(win),500,100);
            }
            else if(to_make==4)
            {
                strcpy(cmd,"/usr/share/schedio/plugin_ncy/restriction/files/");
                strcat(cmd,name);
                strcat(cmd,"/on");
                f=fopen(cmd,"r");
                if(f!=NULL)
                {
                    fclose(f);
                    label=gtk_label_new("Le profil est actuellement activé.");
                    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

                    button = gtk_button_new_with_label("Désactiver le profil");
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(unactivate),NULL);
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
                    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);
                    gtk_window_resize(GTK_WINDOW(win),500,100);
                }
                else
                {
                    g_slist_append(list,(gpointer)vbox);
                    g_slist_append(list,(gpointer)hbox);
                    label=gtk_label_new("Le profil est actuellement désactivé.");
                    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

                    button = gtk_button_new_with_label("Activer le profil");
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(activate),list);
                    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);
                    gtk_window_resize(GTK_WINDOW(win),500,100);
                }
            }
            else if(to_make==5)
            {
                    label=gtk_label_new("Activer ou désactiver le script ?");
                    gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);

                    button = gtk_button_new_with_label("Désactiver");
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(script_off),NULL);
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
                    gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
                    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);

                    button = gtk_button_new_with_label("Activer");
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(script_on),NULL);
                    gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
                    gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 5);
                    gtk_window_resize(GTK_WINDOW(win),500,100);
            }
        }
        else
        {
            printf("Profil does not exist !\n");

            win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
            gtk_container_set_border_width (GTK_CONTAINER (win),2);
            gtk_window_set_title (GTK_WINDOW (win), "Nom de profil incorrect");
            gtk_window_resize(GTK_WINDOW(win),500,170);
            gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
            gtk_widget_realize (win);
            g_signal_connect (win, "destroy", gtk_main_quit, NULL);

            vbox = gtk_vbox_new (FALSE, 6);
            gtk_container_add (GTK_CONTAINER (win), vbox);
            label=gtk_label_new("Le nom d'utilisateur entré est incorrect, ou n'a pas été trouvé sur l'ordinateur.\nVeuillez réessayer en vérifiant la validité du nom entré.");
            gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 10);
            button = gtk_button_new_with_label("Fermer");
            gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),win);
            gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 10);
        }

        /* Enter the main loop */
        gtk_widget_show_all (win);
        gtk_main ();
    }
    else printf("Argc!=2 : Argc=%d",argc);
    return 0;
}
