// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "export.h"
#include "file.h"
#include "plugin.h"
#include <gtk/gtk.h>

void plugin_export(GSList* list)
{
    char** texte;
    GSList* send=NULL;
    int tmp=0;
    int child_pid;
    FILE* f=NULL;
    int row=0;

    GString *script_file=g_slist_nth_data(list,g_slist_length(list)-3);
    GString *save_file=g_slist_nth_data(list,g_slist_length(list)-2);
    GString *visual_file=g_slist_nth_data(list,g_slist_length(list)-1);

    char *spawn[] = {script_file->str,save_file->str,visual_file->str,NULL};

    texte=g_malloc(sizeof(char*)*nb_type);

    int i=1;
    int j=0;
    int k=0;

    while(i<nb_type)
    {
        if(type[i]==3)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            strcpy(texte[j],gtk_entry_get_text(g_slist_nth_data (list,i)));
            j++;
        }
        if(type[i]==4)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            tmp=gtk_spin_button_get_value_as_int(g_slist_nth_data (list,i));
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        if(type[i]==5)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            if(gtk_toggle_button_get_active(g_slist_nth_data (list,i))) tmp=1;
            else tmp=0;
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        if(type[i]==6)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            tmp=gtk_combo_box_get_active(g_slist_nth_data (list,i));
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        if(type[i]==7)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            tmp=gtk_range_get_value(g_slist_nth_data (list,i));
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        if(type[i]==8)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            if(gtk_toggle_button_get_active(g_slist_nth_data (list,i))) tmp=1;
            else tmp=0;
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        if(type[i]==9)
        {
            texte[j]=g_malloc(sizeof(char*)*500);
            if(gtk_toggle_button_get_active(g_slist_nth_data (list,i))) tmp=1;
            else tmp=0;
            sprintf(texte[j],"%d",tmp);
            j++;
        }
        i++;
    }
    i=1;
    send=g_slist_append(send,texte[0]);
    while(i<j)
    {
        g_slist_append(send,texte[i]);
        i++;
    }
    f=fopen(save_file->str,"w+");
    fclose(f);
    set_param(save_file->str,"Window",j,send);

    i=0;
    while(i<j)
    {
        free(texte[i]);
        i++;
    }
    printf("Free is ok\n");

    child_pid = fork ();
    if(child_pid!=0)
    {
        // parent process
        gtk_widget_destroy(g_slist_nth_data (list,0));
        gtk_main_quit();
    }
    else
    {
        // new rocess
        execvp (script_file->str,spawn);

//            fprintf(stderr, "%s %s %s",script_file->str,spawn[0],spawn[1]);

        fprintf (stderr, "an error occurred in execvp\n");
        abort ();
    }
}
