// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "plugin.h"
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <malloc.h>

GString* keep_name(char* line)
{
    int i=0;
    int j=0;
    char name[200];
    GString *string = NULL;

    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        while(line[i]!='>' && line[i]!=' ')
        {
            name[j]=line[i];
            i++;
            j++;
        }
        name[j]='\0';
    }
    else{
        name[0]='n';
        name[1]='o';
        name[2]='\0';
    }
    usleep(500);

    string = g_string_new(name);

    return string;
}

GString* keep_param(char* line)
{
    int i=0;
    int j=0;
    char param[200];
    GString *string = NULL;

    while((line[i]!='<') && (line[i]!='\n')) i++;
    if(line[i]!='\n')
    {
        i++;
        while(line[i]==' ')i++;
        if(line[i]!='>')
        {
            while(line[i]!='>' && line[i]!='"')i++;
            if(line[i]=='"')i++;
            while(line[i]!='>' && line[i]!='"')
            {
                param[j]=line[i];
                i++;
                j++;
            }
            param[j]='\0';
        }
        else
        {
            param[0]='n';
            param[1]='o';
            param[2]='\0';
        }
    }
    else{
        param[0]='n';
        param[1]='o';
        param[2]='\0';
    }
    usleep(500);

    string = g_string_new(param);

    return string;
}

int param_count(char* param)
{
    int count=0;
    int i=0;
    while(param[i]!='\0')
    {
        if(param[i]==':') count++;
        i++;
    }
    return count;
}

GString* param_extract(char* param,int num)
{
    int i=7,j=0;
    int count=0;
    char extract[100];
    int end=0;
    GString *string = NULL;

    while(count<num && !end)
    {
        if(param[i]=='"' || param[i]=='\'') end=1;
        if(param[i]==';')
        {
            count++;
            if(param[i+1]=='"' || param[i+1]=='\'')
            {
                end=1;
            }
        }
        i++;
    }
    if(!end)
    {
        while(param[i]!='"' && param[i]!='\'' && param[i]!=';')
        {
            extract[j]=param[i];
            i++;
            j++;
        }
        extract[j]='\0';
    }
    else
    {
        extract[0]='n';
        extract[1]='o';
        extract[2]='\0';
    }
    usleep(500);

    for(i=0;i<strlen(extract);i++)
    {
        extract[i]=extract[i+7];
        if(extract[i]==';')
        {
            extract[i]='\0';
            break;
        }
    }

    string = g_string_new(extract);

    return string;
}
