#ifndef PLANNING_H
#define PLANNING_H
#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <malloc.h>
#include <string.h>

struct day_time
{
    int hour;
    int minute;
    int second;
};
typedef struct day_time day_time;

struct planning
{
    int *day;
    int *month;
    int *year;
    day_time *start;
    day_time *end;
    int nb_elem;
    int len;
};
typedef struct planning planning;

planning* planning_alloc();
int planning_init(planning *p);
int planning_add_day(planning *p,char *day, char *hour1, char *hour2);
int planning_is_activated(planning *p);
int planning_get_length(planning *p);
void planning_reinit(planning *p);
void planning_free(planning *p);

#endif
