// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef VISUAL_H
#define VISUAL_H
#include <gtk/gtk.h>

enum {
  COLUMN_PLUGIN_VISU,
  COLUMN_FILE_VISU,
  N_COLUMNS_VISU
};

void visualisation(GSList* list);
int extract_visual(char* file,GString* first,GString* second,int num);
void update_label(GSList* list_refresh);
void visualisation_ncy();
void refresh_ncy(GSList* list);
void visual_ncy(GSList* list);
void update_label_ncy(GSList* list_refresh);

struct visual{
    GtkWidget *window;
    GtkWidget **label;
    GtkWidget **hbox;
    GtkWidget *vbox;
    GtkWidget *refresh;
    GSList* list_refresh;
};
struct visual visual;

#endif
