#include <stdio.h>
#include <stdlib.h>
#include <time.h>

struct simple{
    int *start;
    int *end;
    char **fsim;
    int nb;
    int *on;
};
typedef struct simple simple;

struct rcal{
    double **start;
    double **end;
    char **fsim;
    int nb;
    int *nbrs;
    int *on;
};
typedef struct rcal rcal;

int get_nb_param(char* file)
{
    FILE* f=NULL;
    char line[1000];
    short eof;
    int i=0;
    int* nb_car;

    f=fopen(file,"r");
    if(f!=NULL)
    {
        nb_car=fgets(line,1000,f);
        eof= feof(f);

        while(eof!=1)
        {
            i++;
            fgets(line,1000,f);
            eof= feof(f);
        }
        fclose(f);
    }
    else i=-1;
    if (nb_car==NULL) i=-1;

    return i;
}

int end_restrict()
{
    char place[1000];
    char cmd[1000];
    FILE *f=NULL,*flog=NULL;
    int nb,i=0;

    nb=get_nb_param("/usr/share/schedio/plugin_ncy/restriction/files/next");
    f=fopen("/usr/share/schedio/plugin_ncy/restriction/files/next","r");
    if(f!=NULL)
    {
        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","w+");
        while(i<nb)
        {
            fgets(place,1000,f);
            place[strlen(place)-1]='\0';
            strcpy(cmd,"chmod a+x ");
            strcat(cmd,place);
            printf("cmd:%s\n",cmd);

            fprintf(flog,"cmd:%s\n",cmd);

            system(cmd);
            i++;
        }
        fclose(flog);
        fclose(f);
    }
    // chmod a-x retire l'exec
    // chmod a+x donne l'exec
    return 0;
}

int main()
{
    int i=0,equal,nb_user,nb,j,k,l,m;
    int profil_current=-1;
    int* nb_car;
    double dt;

    char name[1000];
    char name_old[1000];
    char line[1000],line_tmp[1000];
    char* filename=NULL;
    char* fileon=NULL;

    FILE* flog=NULL;


    FILE* f=NULL,*next=NULL,*fon=NULL,*frcal=NULL;
    name_old[0]='\0';
    name[0]='\0';
    char **profil=NULL;
    int *profil_nb=NULL;
    char ***profil_strict=NULL;

    int *profil_on=NULL;
    char cmd[1000];
    char cmd_tmp[1000];

    /** For time depends **/

    simple* profil_simple=NULL;
    struct timeval tv;
    struct tm* ptm;
    int actual_time=0;
    int signal_end=0;
    double actual_rcal=0;

    rcal* profil_rcal=NULL;

    gettimeofday(&tv,NULL);
    ptm=localtime(&tv.tv_sec);

    actual_time=10000*(ptm->tm_hour)+100*(ptm->tm_min)+(ptm->tm_sec);
    actual_rcal=(double)(ptm->tm_hour)*3600+(ptm->tm_min)*60+(ptm->tm_sec)+100000*((double)ptm->tm_mday)+10000000*((double)ptm->tm_mon+1)+1000000000*((double)ptm->tm_year+1900);
    // Format: YYYYMMDDsssss
    printf("%d - %lf\n",actual_time,actual_rcal);
    flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","w+");
    fprintf(flog,"Base Date:%d - %lf\n",actual_time,actual_rcal);
    fclose(flog);

    /** end **/

    /** Retirer toutes les restrictions du démarrage précédent dans ./restriction/files/next **/
    end_restrict();
    /** Fin **/

    f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp","w+");
    fclose(f);

    system("ls /home >> /usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp");
    nb_user=get_nb_param("/usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp");
    printf("Nb:%d\n",nb_user);

    flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","w+");
    fprintf(flog,"Nb:%d\n",nb_user);
    fclose(flog);


    if(nb_user>0)
    {
        profil=malloc(sizeof(char*)*nb_user);
        profil_nb=malloc(sizeof(int)*nb_user);
        profil_on=malloc(sizeof(int)*nb_user);
        profil_simple=malloc(sizeof(simple)*nb_user);
        profil_rcal=malloc(sizeof(rcal)*nb_user);
    }

    f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp","r");
    i=0;
    while(i<nb_user)
    {
        profil[i]=malloc(sizeof(char)*1000);
        fgets(line,1000,f);
        strcpy(profil[i],line);
        profil[i][strlen(profil[i])-1]='\0';
        printf("Profil:%s\n",profil[i]);

        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
        fprintf(flog,"Profil:%s\n",profil[i]);
        fclose(flog);

        i++;
    }
    fclose(f);

    profil_strict=malloc(sizeof(char**)*nb_user);

    filename=malloc(sizeof(char)*(400+sizeof("/usr/share/schedio/plugin_ncy/restriction/files/")));
    fileon=malloc(sizeof(char)*(200+sizeof("/usr/share/schedio/plugin_ncy/restriction/files/")));

    i=0;
    next=fopen("/usr/share/schedio/plugin_ncy/restriction/files/next","w+");
    while(i<nb_user)
    {
        /** GET NB RESTRICT **/
        strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
        strcat(filename,profil[i]);
        strcat(filename,"/");
        strcat(filename,profil[i]);
        nb=get_nb_param(filename);

        printf("filename:%s:%d\n",filename,nb);
        profil_nb[i]=nb;

        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
        fprintf(flog,"filename:%s:%d\n",filename,nb);
        fclose(flog);

        /** END GET NB **/

        /** Verif ON OFF **/
        strcpy(fileon,"/usr/share/schedio/plugin_ncy/restriction/files/");
        strcat(fileon,profil[i]);
        strcat(fileon,"/on");

        fon=NULL;
        fon=fopen(fileon,"r");
        if(fon!=NULL)
        {
            profil_on[i]=1;
            fclose(fon);
        }
        else profil_on[i]=0;

        printf("%s:%d\n",profil[i],profil_on[i]);

        /** End verif ON OFF **/

        /** LOAD STRICT **/

        f=NULL;
        f=fopen(filename,"r");
        if(f!=NULL)
        {
            printf("filename exists\n");
            profil_strict[i]=malloc(sizeof(char*)*nb);
            j=0;
            while(j<nb)
            {
                profil_strict[i][j]=malloc(sizeof(char)*1000);
                fgets(line,1000,f);
                strcpy(profil_strict[i][j],line);
                profil_strict[i][j][strlen(profil_strict[i][j])-1]='\0';
                printf("Strict:%s\n",profil_strict[i][j]);
                fprintf(next,"%s\n",profil_strict[i][j]);

                j++;
            }
            fclose(f);
        }

        /** LOAD SIMPLE **/

        strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
        strcat(filename,profil[i]);
        strcat(filename,"/simple.s");
        (profil_simple[i]).nb=get_nb_param(filename);
        ((profil_simple[i]).nb)/=3;

        printf("filename:%s:%d\n",filename,(profil_simple[i]).nb);

        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
        fprintf(flog,"filename:%s:%d\n",filename,(profil_simple[i]).nb);
        fclose(flog);

        nb=(profil_simple[i]).nb;

        f=NULL;
        f=fopen(filename,"r");
        if(f!=NULL)
        {
            printf("filename exists\n");
            (profil_simple[i]).fsim=malloc(sizeof(char*)*nb);
            (profil_simple[i]).start=malloc(sizeof(int)*nb);
            (profil_simple[i]).end=malloc(sizeof(int)*nb);
            (profil_simple[i]).on=malloc(sizeof(int)*nb);

            j=0;
            while(j<((profil_simple[i]).nb))
            {
                ((profil_simple[i]).fsim)[j]=malloc(sizeof(char)*1000);
                fgets(line,1000,f);

                strcpy(((profil_simple[i]).fsim)[j],line);
                ((profil_simple[i]).fsim)[j][strlen(((profil_simple[i]).fsim)[j])-1]='\0';

                fgets(line,1000,f);
                sscanf(line,"%d",&(((profil_simple[i]).start)[j]));

                fgets(line,1000,f);
                sscanf(line,"%d",&(((profil_simple[i]).end)[j]));

                (profil_simple[i]).on[j]=0;

                printf("Simple:%s %d %d\n",((profil_simple[i]).fsim)[j],((profil_simple[i]).start)[j],((profil_simple[i]).end)[j]);
                fprintf(next,"%s\n",((profil_simple[i]).fsim)[j]);
                j++;
            }
            fclose(f);
        }

        /** LOAD RCAL **/

        strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
        strcat(filename,profil[i]);
        strcat(filename,"/calendrier/calendrier.conf");
        (profil_rcal[i]).nb=get_nb_param(filename);

        printf("Profil_rcal_nb=%d\n",(profil_rcal[i]).nb);

        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
        fprintf(flog,"filename:%s:%d\n",filename,(profil_rcal[i]).nb);
        fclose(flog);

        nb=(profil_rcal[i]).nb;

        f=NULL;
        f=fopen(filename,"r");
        if(f!=NULL)
        {
            printf("filename exists\n");
            (profil_rcal[i]).fsim=malloc(sizeof(char*)*nb);
            (profil_rcal[i]).start=malloc(sizeof(double*)*nb);
            (profil_rcal[i]).end=malloc(sizeof(double*)*nb);
            (profil_rcal[i]).on=malloc(sizeof(int)*nb);
            (profil_rcal[i]).nbrs=malloc(sizeof(int)*nb);

            j=0;
            while(j<((profil_rcal[i]).nb))
            {
                ((profil_rcal[i]).fsim)[j]=malloc(sizeof(char)*1000);
                fgets(line,1000,f);

                strcpy(((profil_rcal[i]).fsim)[j],line);
                ((profil_rcal[i]).fsim)[j][strlen(((profil_rcal[i]).fsim)[j])-1]='\0';

                (profil_rcal[i]).on[j]=0;

                printf("Rcal:%s\n",((profil_rcal[i]).fsim)[j]);
                fprintf(next,"%s\n",((profil_rcal[i]).fsim)[j]);

                strcpy(cmd_tmp,(profil_rcal[i]).fsim[j]);
                l=0;
                k=0;
                while(((profil_rcal[i]).fsim[j][l])!='\0')
                {
                    if((profil_rcal[i]).fsim[j][l]=='/') k=-1;
                    else cmd_tmp[k]=(profil_rcal[i]).fsim[j][l];
                    l++;
                    k++;
                }
                cmd_tmp[k]='\0';

                strcpy(filename,"/usr/share/schedio/plugin_ncy/restriction/files/");
                strcat(filename,profil[i]);
                strcat(filename,"/calendrier/");
                strcat(filename,cmd_tmp);
                nb=get_nb_param(filename);

                nb-=6;
                nb/=3;

                if(nb<0) nb=0;

                printf("File:%s %d\n",cmd_tmp,nb);

                flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                fprintf(flog,"File:%s:%d\n",cmd_tmp,nb);
                fclose(flog);


                if(nb>0)
                {
                    (profil_rcal[i]).start[j]=malloc(sizeof(double)*nb);
                    (profil_rcal[i]).end[j]=malloc(sizeof(double)*nb);
                }
                (profil_rcal[i]).nbrs[j]=nb;

                frcal=NULL;
                frcal=fopen(filename,"r");
                if(frcal!=NULL)
                {
                    k=0;
                    while(k<6)
                    {
                        fgets(line,1000,frcal);
                        k++;
                    }
                    k=0;
                    while(k<nb)
                    {
                        (profil_rcal[i]).start[j][k]=0;

                        fgets(line,1000,frcal);

                        line_tmp[0]=line[1];
                        line_tmp[1]=line[2];
                        line_tmp[2]='\0';

                        sscanf(line_tmp,"%lf",&dt);
                        dt*=100000;
                        (profil_rcal[i]).start[j][k]+=dt;
                        (profil_rcal[i]).end[j][k]+=dt;

                        line_tmp[0]=line[3];
                        line_tmp[1]=line[4];
                        line_tmp[2]='\0';

                        sscanf(line_tmp,"%lf",&dt);
                        dt*=10000000;
                        (profil_rcal[i]).start[j][k]+=dt;
                        (profil_rcal[i]).end[j][k]+=dt;

                        line_tmp[0]=line[5];
                        line_tmp[1]=line[6];
                        line_tmp[2]=line[7];
                        line_tmp[3]=line[8];
                        line_tmp[4]='\0';

                        sscanf(line_tmp,"%lf",&dt);
                        dt*=1000000000;
                        (profil_rcal[i]).start[j][k]+=dt;
                        (profil_rcal[i]).end[j][k]+=dt;

                        fgets(line,1000,frcal);
                        line[strlen(line)-1]='\0';
                        sscanf(line,"%d",&l);

                        (profil_rcal[i]).start[j][k]+=l;

                        fgets(line,1000,frcal);
                        line[strlen(line)-1]='\0';
                        sscanf(line,"%d",&l);

                        (profil_rcal[i]).end[j][k]+=l;

                        printf("Found:%lf to %lf\n",(profil_rcal[i]).start[j][k],(profil_rcal[i]).end[j][k]);
                        k++;
                    }
                }

                j++;
            }
            fclose(f);
        }

        i++;
    }
    fclose(next);


    while(1)
    {
        gettimeofday(&tv,NULL);
        ptm=localtime(&tv.tv_sec);
        actual_time=10000*(ptm->tm_hour)+100*(ptm->tm_min)+(ptm->tm_sec);
        actual_rcal=(double)(ptm->tm_hour)*3600+(ptm->tm_min)*60+(ptm->tm_sec)+100000*((double)ptm->tm_mday)+10000000*((double)ptm->tm_mon+1)+1000000000*((double)ptm->tm_year+1900);

        f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp","w+");
        fclose(f);

        system("users >> /usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp");
        f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/users.tmp","r");
        nb_car=fgets(line,1000,f);
        fclose(f);

        if(nb_car!=NULL)
        {
            signal_end=0;
            /** STRICT **/
            i=0;
            while(line[i]!=' ' && i<1000 && line[i]!='\n')
            {
                name[i]=line[i];
                i++;
            }
            name[i]='\0';

            equal=strcmp(name,name_old);

            i=0;
            while(equal!=0 && i<nb_user) // On cherche le nouvel utilisateur
            {
                equal=strcmp(profil[i],name);
                i++;
            }
            if(equal!=0) // Si on a rien trouvé, il y a une erreur
            {
                profil_current=-1;
                end_restrict();
            }
            else if(i!=0) // S'il n'y a pas d'erreur et que le profil a changé
            {
                /** On retire les restrictions **/
                end_restrict();
                signal_end=1; // Il faut réinitialiser tous les simples
                /** Fin **/
                profil_current=i-1;
                if(profil_current!=-1 && profil_on[profil_current])
                {
                    /** Restriction **/
                    printf("Size:%d && profil_on\n",profil_nb[profil_current]);
                    i=0;
                    while(i<profil_nb[profil_current])
                    {
                        strcpy(cmd,"chmod a-x ");
                        strcat(cmd,profil_strict[profil_current][i]);
                        printf("cmd:%s\n",cmd);
                        system(cmd);

                        flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                        fprintf(flog,"cmd:%s\n",cmd);
                        fclose(flog);

                        i++;
                    }
                }
                else if(!profil_on[profil_current]) printf("profil_off\n");
            printf("Current:%d\n",profil_current);
            }
            strcpy(name_old,name);

            /** END STRICT **/

            /** SIMPLE **/

            if(profil_current!=-1)
            {
                j=0;
                while(j<((profil_simple[profil_current]).nb))
                {
                    if(signal_end==1)
                    {
                        ((profil_simple[profil_current]).on)[j]=0;
                    }
                    if(((profil_simple[profil_current]).on)[j]==0) // No restriction
                    {
                        if(actual_time>=((profil_simple[profil_current]).start)[j] && actual_time<=((profil_simple[profil_current]).end)[j])
                        {
                            // RESTRICT BEGIN
                            strcpy(cmd_tmp,(profil_simple[profil_current]).fsim[j]);
                            i=0;
                            k=0;
                            while(((profil_simple[profil_current]).fsim[j][i])!='\0')
                            {
                                if((profil_simple[profil_current]).fsim[j][i]=='/') k=-1;
                                else cmd_tmp[k]=(profil_simple[profil_current]).fsim[j][i];
                                i++;
                                k++;
                            }
                            cmd_tmp[k]='\0';
                            strcpy(cmd,"ps -eo pid,command | grep -v grep | grep -v defunct | grep ");
                            strcat(cmd,cmd_tmp);
                            strcat(cmd," > /usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");

                            printf("cmd:%s\n",cmd);
                            system("rm /usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");
                            system(cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            nb=get_nb_param("/usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");
                            f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp","r");
                            i=0;
                            while(i<nb)
                            {
                                k=0;
                                fgets(line,1000,f);
                                while(line[k]!=' ') k++;
                                l=0;
                                k++;
                                while(line[k]!=' ')
                                {
                                    line_tmp[l]=line[k];
                                    k++;
                                    l++;
                                }
                                line_tmp[l]='\0';

                                strcpy(cmd,"kill -15 ");
                                strcat(cmd,line_tmp);

                                printf("cmd:%s\n",cmd);

                                flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                                fprintf(flog,"cmd:%s\n",cmd);
                                fclose(flog);

                                system(cmd);

                                i++;
                            }
                            fclose(f);

                            strcpy(cmd,"chmod a-x ");
                            strcat(cmd,(profil_simple[profil_current]).fsim[j]);
                            printf("cmd:%s\n",cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            system(cmd);

                            ((profil_simple[profil_current]).on)[j]=1;
                        }
                    }
                    else if(((profil_simple[profil_current]).on)[j]==1)
                    {
                        if(actual_time<=((profil_simple[profil_current]).start)[j] || actual_time>=((profil_simple[profil_current]).end)[j])
                        {
                            // RESTRICT STOP
                            strcpy(cmd,"chmod a+x ");
                            strcat(cmd,(profil_simple[profil_current]).fsim[j]);
                            printf("cmd:%s\n",cmd);

                            system(cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            ((profil_simple[profil_current]).on)[j]=0;
                        }
                    }
                    else ((profil_simple[profil_current]).on)[j]=0; // reinit
                    j++;
                }
            }

            /** END SIMPLE **/

            /** RCAL **/

            if(profil_current!=-1)
            {
                j=0;
                while(j<((profil_rcal[profil_current]).nb))
                {
                    if(signal_end==1)
                    {
                        ((profil_rcal[profil_current]).on)[j]=0;
                    }
                    if(((profil_rcal[profil_current]).on)[j]==0) // No restriction
                    {
                        k=0;
                        l=0;
                        while(k<(profil_rcal[profil_current]).nbrs[j])
                        {
                            if(actual_rcal>=((profil_rcal[profil_current]).start)[j][k] && actual_rcal<=((profil_rcal[profil_current]).end)[j][k]) l++;
                            k++;
                        }

                        if(l>=1 && ((profil_rcal[profil_current]).on)[j]==0)
                        {
                            // RESTRICT BEGIN
                            strcpy(cmd_tmp,(profil_rcal[profil_current]).fsim[j]);
                            i=0;
                            k=0;
                            while(((profil_rcal[profil_current]).fsim[j][i])!='\0')
                            {
                                if((profil_rcal[profil_current]).fsim[j][i]=='/') k=-1;
                                else cmd_tmp[k]=(profil_rcal[profil_current]).fsim[j][i];
                                i++;
                                k++;
                            }
                            cmd_tmp[k]='\0';
                            strcpy(cmd,"ps -eo pid,command | grep -v grep | grep -v defunct | grep ");
                            strcat(cmd,cmd_tmp);
                            strcat(cmd," > /usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");

                            printf("cmd:%s\n",cmd);
                            system("rm /usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");
                            system(cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            nb=get_nb_param("/usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp");
                            f=fopen("/usr/share/schedio/plugin_ncy/restriction/tmp/ps.tmp","r");
                            i=0;
                            while(i<nb)
                            {
                                k=0;
                                fgets(line,1000,f);
                                while(line[k]!=' ') k++;
                                l=0;
                                k++;
                                while(line[k]!=' ')
                                {
                                    line_tmp[l]=line[k];
                                    k++;
                                    l++;
                                }
                                line_tmp[l]='\0';

                                strcpy(cmd,"kill -15 ");
                                strcat(cmd,line_tmp);

                                printf("cmd:%s\n",cmd);

                                flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                                fprintf(flog,"cmd:%s\n",cmd);
                                fclose(flog);

                                system(cmd);

                                i++;
                            }
                            fclose(f);

                            strcpy(cmd,"chmod a-x ");
                            strcat(cmd,(profil_rcal[profil_current]).fsim[j]);
                            printf("cmd:%s\n",cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            system(cmd);

                            ((profil_rcal[profil_current]).on)[j]=1;
                        }
                    }
                    else if(((profil_rcal[profil_current]).on)[j]==1)
                    {
                        k=0;
                        l=0;
                        while(k<(profil_rcal[profil_current]).nbrs[j])
                        {
                            if(actual_rcal>=((profil_rcal[profil_current]).start)[j][k] && actual_rcal<=((profil_rcal[profil_current]).end)[j][k]) l++;
                            k++;
                        }
                        if(l==0)
                        {
                            // RESTRICT STOP
                            strcpy(cmd,"chmod a+x ");
                            strcat(cmd,(profil_rcal[profil_current]).fsim[j]);
                            printf("cmd:%s\n",cmd);

                            system(cmd);

                            flog=fopen("/usr/share/schedio/plugin_ncy/restriction/log","a+");
                            fprintf(flog,"cmd:%s\n",cmd);
                            fclose(flog);

                            ((profil_rcal[profil_current]).on)[j]=0;
                        }
                    }
                    else ((profil_rcal[profil_current]).on)[j]=0; // reinit
                    j++;
                }
            }

            /** END RCAL **/
        }
        else
        {
            printf("Nobody_connected\n");
        }

        sleep(1);
    }
    return 0;
}
