// Copyright © 2010 DELAYEN Julien, DELAYEN Florent

/*
    This file is part of Schedio.

    Schedio is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Schedio is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Schedio.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FILE_H
#define FILE_H
#include <gtk/gtk.h>

int set_param(char* file, char* name, int nb, GSList* gslist); // return 0 if all right
int get_nb_param(char* file); // return the number of params
int get_param(char* file,int nb,char** param); // return 0 if all right
int add_line(char* file,int pid,char* name); // return 0 if all right
int modify_line(char* file,int line,int pid); // return 0 if all right
int del_line(char* file,int line); // return 0 if all right
GString* new_visual_name();
GString* get_visual_name(char* file,int line);
int get_visual_name_row(char* file,char* name);
int get_pid(char *file,int line);

#endif
